Index: src/benchmark/bfs-bench.cc
===================================================================
--- src/benchmark/bfs-bench.cc	(revision 921)
+++ src/benchmark/bfs-bench.cc	(revision 986)
@@ -47,5 +47,5 @@
     Q.pop();
     for(OutEdgeIt e(G,n);e!=INVALID;++e)
-      if(!visited[m=G.head(e)]) {
+      if(!visited[m=G.target(e)]) {
 	Q.push(m);
 	visited.set(m,true);
@@ -75,5 +75,5 @@
     Node n=Q[Qt++];
     for(OutEdgeIt e(G,n);e!=INVALID;++e)
-      if(!visited[m=G.head(e)]) {
+      if(!visited[m=G.target(e)]) {
 	Q[Qh++]=m;
 	visited.set(m,true);
Index: src/demo/dim_to_dot.cc
===================================================================
--- src/demo/dim_to_dot.cc	(revision 931)
+++ src/demo/dim_to_dot.cc	(revision 986)
@@ -52,5 +52,5 @@
   cout << "  edge [ shape=ellipse, fontname=Helvetica, fontsize=10 ];" << endl;
   for(EdgeIt e(g); e!=INVALID; ++e) {
-    cout << "  n" << g.id(g.tail(e)) << " -> " << " n" << g.id(g.head(e))
+    cout << "  n" << g.id(g.source(e)) << " -> " << " n" << g.id(g.target(e))
 	 << " [ label=\"" << g.id(e) 
 	 << ", length:" << length[e] << "\" ]; " << endl;
Index: src/demo/sub_graph_wrapper_demo.cc
===================================================================
--- src/demo/sub_graph_wrapper_demo.cc	(revision 932)
+++ src/demo/sub_graph_wrapper_demo.cc	(revision 986)
@@ -38,8 +38,8 @@
   readDimacs(std::cin, g, length, s, t);
 
-  cout << "edges with lengths (of form id, tail--length->head): " << endl;
+  cout << "edges with lengths (of form id, source--length->target): " << endl;
   for(EdgeIt e(g); e!=INVALID; ++e) 
-    cout << " " << g.id(e) << ", " << g.id(g.tail(e)) << "--" 
-	 << length[e] << "->" << g.id(g.head(e)) << endl;
+    cout << " " << g.id(e) << ", " << g.id(g.source(e)) << "--" 
+	 << length[e] << "->" << g.id(g.target(e)) << endl;
 
   cout << "s: " << g.id(s) << " t: " << g.id(t) << endl;
@@ -76,5 +76,5 @@
     if (flow[e])
       cout << " " << g.id(e) << ", "
-	   << g.id(g.tail(e)) << "--" 
-	   << length[e] << "->" << g.id(g.head(e)) << endl;
+	   << g.id(g.source(e)) << "--" 
+	   << length[e] << "->" << g.id(g.target(e)) << endl;
 }
Index: src/demo/tight_edge_filter_map.h
===================================================================
--- src/demo/tight_edge_filter_map.h	(revision 929)
+++ src/demo/tight_edge_filter_map.h	(revision 986)
@@ -32,6 +32,6 @@
   /// A node-map node_potential is said to be a potential w.r.t. 
   /// an edge-map edge_distance 
-  /// if and only if for each edge e, node_potential[g.head(e)] 
-  /// <= edge_distance[e]+node_potential[g.tail(e)] 
+  /// if and only if for each edge e, node_potential[g.target(e)] 
+  /// <= edge_distance[e]+node_potential[g.source(e)] 
   /// (or the reverse inequality holds for each edge).
   /// An edge is said to be tight if this inequality holds with equality, 
@@ -52,6 +52,6 @@
       edge_distance(&_edge_distance) { }
     bool operator[](const typename Graph::Edge& e) const {
-      return ((*node_potential)[g->head(e)] == 
-	      (*edge_distance)[e]+(*node_potential)[g->tail(e)]);
+      return ((*node_potential)[g->target(e)] == 
+	      (*edge_distance)[e]+(*node_potential)[g->source(e)]);
     }
   };
Index: src/lemon/bfs.h
===================================================================
--- src/lemon/bfs.h	(revision 977)
+++ src/lemon/bfs.h	(revision 986)
@@ -210,5 +210,5 @@
 	
 	for(OutEdgeIt e(*G,n);e!=INVALID;++e)
-	  if((m=G->head(e))!=s && (*predecessor)[m]==INVALID) {
+	  if((m=G->target(e))!=s && (*predecessor)[m]==INVALID) {
 	    Q[Qh++]=m;
 	    predecessor->set(m,e);
Index: src/lemon/concept/graph.h
===================================================================
--- src/lemon/concept/graph.h	(revision 961)
+++ src/lemon/concept/graph.h	(revision 986)
@@ -364,14 +364,14 @@
 //       EdgeIt& first(EdgeIt& i) const { return i; }
 
-//       ///Gives back the head node of an edge.
-
-//       ///Gives back the head node of an edge.
-//       ///
-//       Node head(Edge) const { return INVALID; }
-//       ///Gives back the tail node of an edge.
-
-//       ///Gives back the tail node of an edge.
-//       ///
-//       Node tail(Edge) const { return INVALID; }
+//       ///Gives back the target node of an edge.
+
+//       ///Gives back the target node of an edge.
+//       ///
+//       Node target(Edge) const { return INVALID; }
+//       ///Gives back the source node of an edge.
+
+//       ///Gives back the source node of an edge.
+//       ///
+//       Node source(Edge) const { return INVALID; }
   
 //       ///Gives back the \e id of a node.
@@ -539,6 +539,6 @@
 // 	Edge e;
 // 	e=INVALID;
-// 	n=G.tail(e);
-// 	n=G.head(e);
+// 	n=G.source(e);
+// 	n=G.target(e);
 //       }
 //       // id tests
@@ -666,6 +666,6 @@
 //       ///Add a new edge to the graph.
 
-//       ///Add a new edge to the graph with tail node \c t
-//       ///and head node \c h.
+//       ///Add a new edge to the graph with source node \c t
+//       ///and target node \c h.
 //       ///\return the new edge.
 //       Edge addEdge(Node h, Node t) { return INVALID; }
@@ -801,6 +801,6 @@
       void nextInEdge(Edge &e) const { }
 
-      Node head(Edge) const { return Node(); }
-      Node tail(Edge) const { return Node(); }
+      Node target(Edge) const { return Node(); }
+      Node source(Edge) const { return Node(); }
       
 
Index: src/lemon/concept/graph_component.h
===================================================================
--- src/lemon/concept/graph_component.h	(revision 980)
+++ src/lemon/concept/graph_component.h	(revision 986)
@@ -243,15 +243,15 @@
       };
 
-      ///Gives back the head node of an edge.
-
-      ///Gives back the head node of an edge.
-      ///
-      Node head(const Edge&) const { return INVALID;}
-
-      ///Gives back the tail node of an edge.
-
-      ///Gives back the tail node of an edge.
-      ///
-      Node tail(const Edge&) const { return INVALID;}
+      ///Gives back the target node of an edge.
+
+      ///Gives back the target node of an edge.
+      ///
+      Node target(const Edge&) const { return INVALID;}
+
+      ///Gives back the source node of an edge.
+
+      ///Gives back the source node of an edge.
+      ///
+      Node source(const Edge&) const { return INVALID;}
     };
 
@@ -273,6 +273,6 @@
 	  Node n;
 	  Edge e;
-	  n = graph.tail(e);
-	  n = graph.head(e);
+	  n = graph.source(e);
+	  n = graph.target(e);
 	}      
       }
Index: src/lemon/concept/path.h
===================================================================
--- src/lemon/concept/path.h	(revision 967)
+++ src/lemon/concept/path.h	(revision 986)
@@ -67,10 +67,10 @@
       /// Starting point of the path.
       /// Returns INVALID if the path is empty.
-      GraphNode/*It*/ head() const {return INVALID;}
+      GraphNode/*It*/ target() const {return INVALID;}
       /// \brief End point of the path.
       ///
       /// End point of the path.
       /// Returns INVALID if the path is empty.
-      GraphNode/*It*/ tail() const {return INVALID;}
+      GraphNode/*It*/ source() const {return INVALID;}
 
       /// \brief First NodeIt/EdgeIt.
@@ -81,15 +81,15 @@
       It& first(It &i) const { return i=It(*this); }
 
-      /// \brief The head of an edge.
-      ///
-      /// Returns node iterator pointing to the head node of the
+      /// \brief The target of an edge.
+      ///
+      /// Returns node iterator pointing to the target node of the
       /// given edge iterator.
-      NodeIt head(const EdgeIt& e) const {return INVALID;}
-
-      /// \brief The tail of an edge.
-      ///
-      /// Returns node iterator pointing to the tail node of the
+      NodeIt target(const EdgeIt& e) const {return INVALID;}
+
+      /// \brief The source of an edge.
+      ///
+      /// Returns node iterator pointing to the source node of the
       /// given edge iterator.
-      NodeIt tail(const EdgeIt& e) const {return INVALID;}
+      NodeIt source(const EdgeIt& e) const {return INVALID;}
 
 
Index: src/lemon/concept/sym_graph.h
===================================================================
--- src/lemon/concept/sym_graph.h	(revision 959)
+++ src/lemon/concept/sym_graph.h	(revision 986)
@@ -451,14 +451,14 @@
       SymEdgeIt& first(SymEdgeIt& i) const { return i; }
 
-      ///Gives back the head node of an edge.
-
-      ///Gives back the head node of an edge.
-      ///
-      Node head(Edge) const { return INVALID; }
-      ///Gives back the tail node of an edge.
-
-      ///Gives back the tail node of an edge.
-      ///
-      Node tail(Edge) const { return INVALID; }
+      ///Gives back the target node of an edge.
+
+      ///Gives back the target node of an edge.
+      ///
+      Node target(Edge) const { return INVALID; }
+      ///Gives back the source node of an edge.
+
+      ///Gives back the source node of an edge.
+      ///
+      Node source(Edge) const { return INVALID; }
   
       ///Gives back the first node of an symmetric edge.
@@ -466,10 +466,10 @@
       ///Gives back the first node of an symmetric edge.
       ///
-      Node head(SymEdge) const { return INVALID; }
+      Node target(SymEdge) const { return INVALID; }
       ///Gives back the second node of an symmetric edge.
 
       ///Gives back the second node of an symmetric edge.
       ///
-      Node tail(SymEdge) const { return INVALID; }
+      Node source(SymEdge) const { return INVALID; }
       ///Gives back the \e id of a node.
 
@@ -608,6 +608,6 @@
       ///Add a new edge to the graph.
 
-      ///Add a new symmetric edge to the graph with tail node \c t
-      ///and head node \c h.
+      ///Add a new symmetric edge to the graph with source node \c t
+      ///and target node \c h.
       ///\return the new edge.
       SymEdge addEdge(Node h, Node t) { return INVALID; }
Index: src/lemon/concept/undir_graph.h
===================================================================
--- src/lemon/concept/undir_graph.h	(revision 962)
+++ src/lemon/concept/undir_graph.h	(revision 986)
@@ -48,6 +48,6 @@
 
 	Node n;
-	n = graph.head(ue);
-	n = graph.tail(ue);
+	n = graph.target(ue);
+	n = graph.source(ue);
 
 	graph.first(ue);
Index: src/lemon/concept_check.h
===================================================================
--- src/lemon/concept_check.h	(revision 946)
+++ src/lemon/concept_check.h	(revision 986)
@@ -26,5 +26,5 @@
     "inline" is used for ignore_unused_variable_warning()
     and function_requires() to make sure there is no
-    overhead with g++.
+    overtarget with g++.
   */
 
Index: src/lemon/dfs.h
===================================================================
--- src/lemon/dfs.h	(revision 946)
+++ src/lemon/dfs.h	(revision 986)
@@ -207,5 +207,5 @@
       do {
 	if((e=Q[Qh])!=INVALID)
-	  if((m=G->head(e))!=s && (*predecessor)[m=G->head(e)]==INVALID) {
+	  if((m=G->target(e))!=s && (*predecessor)[m=G->target(e)]==INVALID) {
 	    predecessor->set(m,e);
 	    pred_node->set(m,n);
@@ -215,5 +215,5 @@
 	  }
 	  else ++Q[Qh];
-	else if(--Qh>=0) n=G->tail(Q[Qh]);
+	else if(--Qh>=0) n=G->source(Q[Qh]);
       } while(Qh>=0);
     }
Index: src/lemon/dijkstra.h
===================================================================
--- src/lemon/dijkstra.h	(revision 959)
+++ src/lemon/dijkstra.h	(revision 986)
@@ -255,5 +255,5 @@
 	
 	for(OutEdgeIt e(*G,v); e!=INVALID; ++e) {
-	  Node w=G->head(e); 
+	  Node w=G->target(e); 
 	  switch(heap.state(w)) {
 	  case HeapType::PRE_HEAP:
Index: src/lemon/dimacs.h
===================================================================
--- src/lemon/dimacs.h	(revision 964)
+++ src/lemon/dimacs.h	(revision 986)
@@ -209,5 +209,5 @@
 
     for(EdgeIt e(g); e!=INVALID; ++e) {
-      os << "a " << nodes[g.tail(e)] << " " << nodes[g.head(e)] << std::endl; 
+      os << "a " << nodes[g.source(e)] << " " << nodes[g.target(e)] << std::endl; 
     }
 
Index: src/lemon/full_graph.h
===================================================================
--- src/lemon/full_graph.h	(revision 985)
+++ src/lemon/full_graph.h	(revision 986)
@@ -79,6 +79,6 @@
     int maxId(Edge = INVALID) const { return EdgeNum-1; }
 
-    Node tail(Edge e) const { return e.id % NodeNum; }
-    Node head(Edge e) const { return e.id / NodeNum; }
+    Node source(Edge e) const { return e.id % NodeNum; }
+    Node target(Edge e) const { return e.id / NodeNum; }
 
 
@@ -137,10 +137,10 @@
       
     protected:
-      int id;  // NodeNum * head + tail;
+      int id;  // NodeNum * target + source;
 
       Edge(int _id) : id(_id) {}
 
-      Edge(const FullGraphBase& _graph, int tail, int head) 
-	: id(_graph.NodeNum * head+tail) {}
+      Edge(const FullGraphBase& _graph, int source, int target) 
+	: id(_graph.NodeNum * target+source) {}
     public:
       Edge() { }
@@ -251,12 +251,12 @@
     int maxId(Edge = INVALID) const { return EdgeNum-1; }
 
-    Node tail(Edge e) const { 
+    Node source(Edge e) const { 
       /// \todo we may do it faster
       return ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2; 
     }
 
-    Node head(Edge e) const { 
-      int tail = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
-      return e.id - (tail) * (tail - 1) / 2; 
+    Node target(Edge e) const { 
+      int source = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
+      return e.id - (source) * (source - 1) / 2; 
     }
 
@@ -316,10 +316,10 @@
       
     protected:
-      int id;  // NodeNum * head + tail;
+      int id;  // NodeNum * target + source;
 
       Edge(int _id) : id(_id) {}
 
-      Edge(const UndirFullGraphBase& _graph, int tail, int head) 
-	: id(_graph.NodeNum * head+tail) {}
+      Edge(const UndirFullGraphBase& _graph, int source, int target) 
+	: id(_graph.NodeNum * target+source) {}
     public:
       Edge() { }
@@ -352,8 +352,8 @@
     /// \todo with specialized iterators we can make faster iterating
     void nextOut(Edge& e) const {
-      int tail = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
-      int head = e.id - (tail) * (tail - 1) / 2; 
-      ++head;
-      e.id = head < tail ? tail * (tail - 1) / 2 + head : -1;
+      int source = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
+      int target = e.id - (source) * (source - 1) / 2; 
+      ++target;
+      e.id = target < source ? source * (source - 1) / 2 + target : -1;
     }
 
@@ -363,8 +363,8 @@
     
     void nextIn(Edge& e) const {
-      int tail = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
-      int head = e.id - (tail) * (tail - 1) / 2; ++head;
-      ++tail;
-      e.id = tail < NodeNum ? tail * (tail - 1) / 2 + head : -1;
+      int source = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
+      int target = e.id - (source) * (source - 1) / 2; ++target;
+      ++source;
+      e.id = source < NodeNum ? source * (source - 1) / 2 + target : -1;
     }
 
Index: src/lemon/graph_utils.h
===================================================================
--- src/lemon/graph_utils.h	(revision 977)
+++ src/lemon/graph_utils.h	(revision 986)
@@ -150,5 +150,5 @@
     if(prev==INVALID) g.first(e,u);
     else ++e;
-    while(e!=INVALID && g.tail(e)!=v) ++e;
+    while(e!=INVALID && g.source(e)!=v) ++e;
     return e;
   }
@@ -193,5 +193,5 @@
 		 const NodeBijection& _nb, EdgeBijection& _eb) {    
     for (typename SourceGraph::EdgeIt it(_s); it != INVALID; ++it) {
-      _eb[it] = _d.addEdge(_nb[_s.tail(it)], _nb[_s.head(it)]);
+      _eb[it] = _d.addEdge(_nb[_s.source(it)], _nb[_s.target(it)]);
     }
   }
Index: src/lemon/graph_wrapper.h
===================================================================
--- src/lemon/graph_wrapper.h	(revision 970)
+++ src/lemon/graph_wrapper.h	(revision 986)
@@ -151,10 +151,10 @@
     void nextOut(Edge& i) const { graph->nextOut(i); }
 
-    Node tail(const Edge& e) const { return graph->tail(e); }
-    Node head(const Edge& e) const { return graph->head(e); }
-//     Node tail(const Edge& e) const { 
-//       return Node(graph->tail(static_cast<typename Graph::Edge>(e))); }
-//     Node head(const Edge& e) const { 
-//       return Node(graph->head(static_cast<typename Graph::Edge>(e))); }
+    Node source(const Edge& e) const { return graph->source(e); }
+    Node target(const Edge& e) const { return graph->target(e); }
+//     Node source(const Edge& e) const { 
+//       return Node(graph->source(static_cast<typename Graph::Edge>(e))); }
+//     Node target(const Edge& e) const { 
+//       return Node(graph->target(static_cast<typename Graph::Edge>(e))); }
 
     int nodeNum() const { return graph->nodeNum(); }
@@ -162,6 +162,6 @@
   
     Node addNode() const { return Node(graph->addNode()); }
-    Edge addEdge(const Node& tail, const Node& head) const { 
-      return Edge(graph->addEdge(tail, head)); }
+    Edge addEdge(const Node& source, const Node& target) const { 
+      return Edge(graph->addEdge(source, target)); }
 
     void erase(const Node& i) const { graph->erase(i); }
@@ -291,8 +291,8 @@
     }
 
-    Node tail(const Edge& e) const { 
-      return GraphWrapper<Graph>::head(e); }
-    Node head(const Edge& e) const { 
-      return GraphWrapper<Graph>::tail(e); }
+    Node source(const Edge& e) const { 
+      return GraphWrapper<Graph>::target(e); }
+    Node target(const Edge& e) const { 
+      return GraphWrapper<Graph>::source(e); }
 
     //    KEEP_MAPS(Parent, RevGraphWrapper);
@@ -626,8 +626,8 @@
   readDimacs(std::cin, g, length, s, t);
 
-  cout << "edges with lengths (of form id, tail--length->head): " << endl;
+  cout << "edges with lengths (of form id, source--length->target): " << endl;
   for(EdgeIt e(g); e!=INVALID; ++e) 
-    cout << g.id(e) << ", " << g.id(g.tail(e)) << "--" 
-         << length[e] << "->" << g.id(g.head(e)) << endl;
+    cout << g.id(e) << ", " << g.id(g.source(e)) << "--" 
+         << length[e] << "->" << g.id(g.target(e)) << endl;
 
   cout << "s: " << g.id(s) << " t: " << g.id(t) << endl;
@@ -666,10 +666,10 @@
   for(EdgeIt e(g); e!=INVALID; ++e) 
     if (flow[e])
-      cout << " " << g.id(g.tail(e)) << "--" 
-	   << length[e] << "->" << g.id(g.head(e)) << endl;
+      cout << " " << g.id(g.source(e)) << "--" 
+	   << length[e] << "->" << g.id(g.target(e)) << endl;
   \endcode
   The program has the following (expected :-)) output:
   \code
-  edges with lengths (of form id, tail--length->head):
+  edges with lengths (of form id, source--length->target):
    9, 5--4->6
    8, 4--2->6
@@ -757,5 +757,5 @@
     OutEdgeIt& next(OutEdgeIt& e) const {
       if (e.out_or_in) {
-	typename Graph::Node n=this->graph->tail(e.out);
+	typename Graph::Node n=this->graph->source(e.out);
 	this->graph->next(e.out);
 	if (!this->graph->valid(e.out)) { 
@@ -768,9 +768,9 @@
 
     Node aNode(const OutEdgeIt& e) const { 
-      if (e.out_or_in) return this->graph->tail(e); else 
-	return this->graph->head(e); }
+      if (e.out_or_in) return this->graph->source(e); else 
+	return this->graph->target(e); }
     Node bNode(const OutEdgeIt& e) const { 
-      if (e.out_or_in) return this->graph->head(e); else 
-	return this->graph->tail(e); }
+      if (e.out_or_in) return this->graph->target(e); else 
+	return this->graph->source(e); }
 
     //    KEEP_MAPS(Parent, UndirGraphWrapper);
@@ -938,5 +938,5 @@
       OutEdgeIt& operator++() { 
 	if (!this->backward) {
-	  Node n=gw->tail(*this);
+	  Node n=gw->source(*this);
 	  *(static_cast<GraphEdge*>(this))=
 	    ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
@@ -995,5 +995,5 @@
       InEdgeIt& operator++() { 
 	if (!this->backward) {
-	  Node n=gw->tail(*this);
+	  Node n=gw->source(*this);
 	  *(static_cast<GraphEdge*>(this))=
 	    ++(typename Graph::InEdgeIt(*(gw->graph), *this));
@@ -1090,8 +1090,8 @@
   
 
-    Node tail(Edge e) const { 
-      return ((!e.backward) ? this->graph->tail(e) : this->graph->head(e)); }
-    Node head(Edge e) const { 
-      return ((!e.backward) ? this->graph->head(e) : this->graph->tail(e)); }
+    Node source(Edge e) const { 
+      return ((!e.backward) ? this->graph->source(e) : this->graph->target(e)); }
+    Node target(Edge e) const { 
+      return ((!e.backward) ? this->graph->target(e) : this->graph->source(e)); }
 
     /// Gives back the opposite edge.
@@ -1414,5 +1414,5 @@
 //     }
     void erase(const Edge& e) const {
-      Node n=tail(e);
+      Node n=source(e);
       typename Graph::OutEdgeIt f(*Parent::graph, n);
       ++f;
Index: src/lemon/kruskal.h
===================================================================
--- src/lemon/kruskal.h	(revision 921)
+++ src/lemon/kruskal.h	(revision 986)
@@ -83,6 +83,6 @@
     for (typename IN::const_iterator p = in.begin(); 
 	 p!=in.end(); ++p ) {
-      if ( uf.join(G.head((*p).first),
-		   G.tail((*p).first)) ) {
+      if ( uf.join(G.target((*p).first),
+		   G.source((*p).first)) ) {
 	out.set((*p).first, true);
 	tot_cost += (*p).second;
Index: src/lemon/list_graph.h
===================================================================
--- src/lemon/list_graph.h	(revision 980)
+++ src/lemon/list_graph.h	(revision 986)
@@ -44,5 +44,5 @@
  
     struct EdgeT {
-      int head, tail;
+      int target, source;
       int prev_in, prev_out;
       int next_in, next_out;
@@ -112,6 +112,6 @@
     int maxId(Edge = INVALID) const { return edges.size()-1; }
 
-    Node tail(Edge e) const { return edges[e.id].tail; }
-    Node head(Edge e) const { return edges[e.id].head; }
+    Node source(Edge e) const { return edges[e.id].source; }
+    Node target(Edge e) const { return edges[e.id].target; }
 
 
@@ -138,5 +138,5 @@
       } else {
 	int n;
-	for(n = nodes[edges[edge.id].head].next;
+	for(n = nodes[edges[edge.id].target].next;
 	  n!=-1 && nodes[n].first_in == -1; 
 	  n = nodes[n].next);
@@ -199,6 +199,6 @@
       }
       
-      edges[n].tail = u.id; 
-      edges[n].head = v.id;
+      edges[n].source = u.id; 
+      edges[n].target = v.id;
 
       edges[n].next_out = nodes[u.id].first_out;
@@ -247,5 +247,5 @@
 	edges[edges[n].prev_in].next_in = edges[n].next_in;
       } else {
-	nodes[edges[n].head].first_in = edges[n].next_in;
+	nodes[edges[n].target].first_in = edges[n].next_in;
       }
 
@@ -258,5 +258,5 @@
 	edges[edges[n].prev_out].next_out = edges[n].next_out;
       } else {
-	nodes[edges[n].tail].first_out = edges[n].next_out;
+	nodes[edges[n].source].first_out = edges[n].next_out;
       }
       
@@ -273,5 +273,5 @@
 
   protected:
-    void _moveHead(Edge e, Node n) 
+    void _moveTarget(Edge e, Node n) 
     {
       if(edges[e.id].next_in != -1)
@@ -279,11 +279,11 @@
       if(edges[e.id].prev_in != -1)
 	edges[edges[e.id].prev_in].next_in = edges[e.id].next_in;
-      else nodes[edges[e.id].head].first_in = edges[e.id].next_in;
-      edges[e.id].head = n.id;
+      else nodes[edges[e.id].target].first_in = edges[e.id].next_in;
+      edges[e.id].target = n.id;
       edges[e.id].prev_in = -1;
       edges[e.id].next_in = nodes[n.id].first_in;
       nodes[n.id].first_in = e.id;
     }
-    void _moveTail(Edge e, Node n) 
+    void _moveSource(Edge e, Node n) 
     {
       if(edges[e.id].next_out != -1)
@@ -291,6 +291,6 @@
       if(edges[e.id].prev_out != -1)
 	edges[edges[e.id].prev_out].next_out = edges[e.id].next_out;
-      else nodes[edges[e.id].tail].first_out = edges[e.id].next_out;
-      edges[e.id].tail = n.id;
+      else nodes[edges[e.id].source].first_out = edges[e.id].next_out;
+      edges[e.id].source = n.id;
       edges[e.id].prev_out = -1;
       edges[e.id].next_out = nodes[n.id].first_out;
@@ -321,14 +321,14 @@
   {
   public:
-    /// Moves the head of \c e to \c n
-
-    /// Moves the head of \c e to \c n
+    /// Moves the target of \c e to \c n
+
+    /// Moves the target of \c e to \c n
     ///
-    void moveHead(Edge e, Node n) { _moveHead(e,n); }
-    /// Moves the tail of \c e to \c n
-
-    /// Moves the tail of \c e to \c n
+    void moveTarget(Edge e, Node n) { _moveTarget(e,n); }
+    /// Moves the source of \c e to \c n
+
+    /// Moves the source of \c e to \c n
     ///
-    void moveTail(Edge e, Node n) { _moveTail(e,n); }
+    void moveSource(Edge e, Node n) { _moveSource(e,n); }
 
     ///Using this it possible to avoid the superfluous memory allocation.
Index: src/lemon/min_cost_flow.h
===================================================================
--- src/lemon/min_cost_flow.h	(revision 941)
+++ src/lemon/min_cost_flow.h	(revision 986)
@@ -104,7 +104,7 @@
       ValueType operator[](typename ResGW::Edge e) const {     
 	if (g.forward(e))
-	  return  length[e]-(pot[g.head(e)]-pot[g.tail(e)]);   
+	  return  length[e]-(pot[g.target(e)]-pot[g.source(e)]);   
 	else
-	  return -length[e]-(pot[g.head(e)]-pot[g.tail(e)]);   
+	  return -length[e]-(pot[g.target(e)]-pot[g.source(e)]);   
       }     
 	
@@ -236,5 +236,5 @@
         for(typename Graph::EdgeIt e(g); e!=INVALID; ++e) {
 	//C^{\Pi}_{i,j}
-	mod_pot = length[e]-potential[g.head(e)]+potential[g.tail(e)];
+	mod_pot = length[e]-potential[g.target(e)]+potential[g.source(e)];
 	fl_e = flow[e];
 	if (0<fl_e && fl_e<capacity[e]) {
Index: src/lemon/path.h
===================================================================
--- src/lemon/path.h	(revision 959)
+++ src/lemon/path.h	(revision 986)
@@ -112,6 +112,6 @@
     /// Starting point of the path.
     /// Returns INVALID if the path is empty.
-    GraphNode tail() const {
-      return empty() ? INVALID : gr->tail(edges[0]);
+    GraphNode source() const {
+      return empty() ? INVALID : gr->source(edges[0]);
     }
     /// \brief End point of the path.
@@ -119,6 +119,6 @@
     /// End point of the path.
     /// Returns INVALID if the path is empty.
-    GraphNode head() const {
-      return empty() ? INVALID : gr->head(edges[length()-1]);
+    GraphNode target() const {
+      return empty() ? INVALID : gr->target(edges[length()-1]);
     }
 
@@ -140,13 +140,13 @@
     }
 
-    /// \brief Returns node iterator pointing to the head node of the
+    /// \brief Returns node iterator pointing to the target node of the
     /// given edge iterator.
-    NodeIt head(const EdgeIt& e) const {
+    NodeIt target(const EdgeIt& e) const {
       return NodeIt(*this, e.idx+1);
     }
 
-    /// \brief Returns node iterator pointing to the tail node of the
+    /// \brief Returns node iterator pointing to the source node of the
     /// given edge iterator.
-    NodeIt tail(const EdgeIt& e) const {
+    NodeIt source(const EdgeIt& e) const {
       return NodeIt(*this, e.idx);
     }
@@ -231,7 +231,7 @@
       operator const GraphNode& () const {
 	if(idx >= p->length())
-	  return p->head();
+	  return p->target();
 	else if(idx >= 0)
-	  return p->gr->tail(p->edges[idx]);
+	  return p->gr->source(p->edges[idx]);
 	else
 	  return INVALID;
@@ -336,21 +336,21 @@
       }
 
-      GraphNode tail() const {
+      GraphNode source() const {
 	if( ! front.empty() )
-	  return P.gr->tail(front[front.size()-1]);
+	  return P.gr->source(front[front.size()-1]);
 	else if( ! P.empty() )
-	  return P.gr->tail(P.edges[0]);
+	  return P.gr->source(P.edges[0]);
 	else if( ! back.empty() )
-	  return P.gr->tail(back[0]);
+	  return P.gr->source(back[0]);
 	else
 	  return INVALID;
       }
-      GraphNode head() const {
+      GraphNode target() const {
 	if( ! back.empty() )
-	  return P.gr->head(back[back.size()-1]);
+	  return P.gr->target(back[back.size()-1]);
 	else if( ! P.empty() )
-	  return P.gr->head(P.edges[P.length()-1]);
+	  return P.gr->target(P.edges[P.length()-1]);
 	else if( ! front.empty() )
-	  return P.gr->head(front[0]);
+	  return P.gr->target(front[0]);
 	else
 	  return INVALID;
@@ -438,6 +438,6 @@
     /// Starting point of the path.
     /// Returns INVALID if the path is empty.
-    GraphNode tail() const {
-      return empty() ? INVALID : gr->tail(edges[0]);
+    GraphNode source() const {
+      return empty() ? INVALID : gr->source(edges[0]);
     }
     /// \brief End point of the path.
@@ -445,6 +445,6 @@
     /// End point of the path.
     /// Returns INVALID if the path is empty.
-    GraphNode head() const {
-      return empty() ? INVALID : gr->head(edges[length()-1]);
+    GraphNode target() const {
+      return empty() ? INVALID : gr->target(edges[length()-1]);
     }
 
@@ -478,13 +478,13 @@
     }
 
-    /// \brief Returns node iterator pointing to the head node of the
+    /// \brief Returns node iterator pointing to the target node of the
     /// given edge iterator.
-    NodeIt head(const EdgeIt& e) const {
+    NodeIt target(const EdgeIt& e) const {
       return NodeIt(*this, e.idx+1);
     }
 
-    /// \brief Returns node iterator pointing to the tail node of the
+    /// \brief Returns node iterator pointing to the source node of the
     /// given edge iterator.
-    NodeIt tail(const EdgeIt& e) const {
+    NodeIt source(const EdgeIt& e) const {
       return NodeIt(*this, e.idx);
     }
@@ -571,7 +571,7 @@
       operator const GraphNode& () const {
 	if(idx >= p->length())
-	  return p->head();
+	  return p->target();
 	else if(idx >= 0)
-	  return p->gr->tail(p->edges[idx]);
+	  return p->gr->source(p->edges[idx]);
 	else
 	  return INVALID;
@@ -677,21 +677,21 @@
       }
 
-      GraphNode tail() const {
+      GraphNode source() const {
 	if( ! front.empty() )
-	  return P.gr->tail(front[front.size()-1]);
+	  return P.gr->source(front[front.size()-1]);
 	else if( ! P.empty() )
-	  return P.gr->tail(P.edges[0]);
+	  return P.gr->source(P.edges[0]);
 	else if( ! back.empty() )
-	  return P.gr->tail(back[0]);
+	  return P.gr->source(back[0]);
 	else
 	  return INVALID;
       }
-      GraphNode head() const {
+      GraphNode target() const {
 	if( ! back.empty() )
-	  return P.gr->head(back[back.size()-1]);
+	  return P.gr->target(back[back.size()-1]);
 	else if( ! P.empty() )
-	  return P.gr->head(P.edges[P.length()-1]);
+	  return P.gr->target(P.edges[P.length()-1]);
 	else if( ! front.empty() )
-	  return P.gr->head(front[0]);
+	  return P.gr->target(front[0]);
 	else
 	  return INVALID;
